#ifndef GLCD_H
#define GLCD_H

#include <stdint.h>         /* For uint8_t definition */

#define GLCD_COLOR_WHITE   0
#define GLCD_COLOR_BLACK   1
#define GLCD_FONT_3x5      0
#define GLCD_FONT_4x5      1
#define GLCD_FONT_5x7      2
#define GLCD_ROTATE_0      0
#define GLCD_ROTATE_90     1
#define GLCD_ROTATE_180    2
#define GLCD_ROTATE_270    3

void LCD_string(uint8_t *buff, char *str, uint8_t x, uint8_t y, uint8_t rotate, uint8_t font, uint8_t color);
void LCD_char(uint8_t *buff, char digit, uint8_t x, uint8_t y, uint8_t rotate, uint8_t font, uint8_t color);
void LCD_rect(uint8_t *buff, uint8_t x1, uint8_t y1, uint8_t x2, uint8_t y2, uint8_t color, uint8_t fill);
void LCD_line(uint8_t *buff, uint8_t x1, uint8_t y1, uint8_t x2, uint8_t y2, uint8_t color);
void LCD_circle(uint8_t *buff, uint8_t xpos, uint8_t ypos, uint8_t rad, uint8_t color);
void LCD_setpixel(uint8_t *buff, uint8_t x, uint8_t y, uint8_t color);
void LCD_dot(uint8_t *buff, uint8_t x, uint8_t y, uint8_t thick, uint8_t color);

#endif // GLCD_H
