#include <QtGui>

#include "glcdwidget.h"



glcdwidget::glcdwidget(QWidget *parent): QWidget(parent)
{
//    QTimer *timer = new QTimer(this);
//    connect(timer, SIGNAL(timeout()), this, SLOT(update()));
//    timer->start(1000);

    resize(mLCD_WIDTH*4, mLCD_HEIGHT*4);
    memset(map,0,sizeof(map));
    chipsel = 0;
    row = 0;
    col = 0;
}

void glcdwidget::glcd_cmd(unsigned char cmd)
{
#define mLCD_SET_ADDR    	0x40
#define mLCD_SET_PAGE    	0xB8
    if ((cmd & 0xC0) == mLCD_SET_ADDR)
        col = cmd & 0x3F;
    if ((cmd & 0xF8) == mLCD_SET_PAGE)
        row = cmd & 0x07;
}

void glcdwidget::glcd_out(unsigned char dat)
{
    if (chipsel & 0x01)
    {
        for (int i=0;i<8;i++)
            map[row*8+i][col] = (dat & (1<<i))?true:false;
    }
    if (chipsel & 0x02)
    {
        for (int i=0;i<8;i++)
            map[row*8+i][64+col] = (dat & (1<<i))?true:false;
    }
    col++;
    col = col & 0x3F;
    update();
}

void glcdwidget::glcd_cs(unsigned char cs)
{
    if (chipsel <= 3)
        chipsel = cs;
}

void glcdwidget::paintEvent(QPaintEvent *)
{
    QPainter painter(this);
    //painter.setRenderHint(QPainter::Antialiasing);
    painter.setPen(Qt::NoPen);
    painter.translate(mLCD_HEIGHT*4,0);
    painter.rotate(90.0); // rotate around point 0,0; need to shift it to the right by image height

    painter.setBrush(Qt::lightGray);
    for (int i=0;i<mLCD_HEIGHT;i++)
        for (int j=0;j<mLCD_WIDTH;j++)
            painter.drawRect(j*4,i*4,3,3);

    painter.setBrush(Qt::black);
    for (int i=0;i<mLCD_HEIGHT;i++)
        for (int j=0;j<mLCD_WIDTH;j++)
            if (map[i][j])
                painter.drawRect(j*4,i*4,3,3);
}
